* [Hello World](#hello-world)
* [Bindings](#bindings)
* [Dynamic Bindings](#dynamic-bindings)
* [Forward Bindings](#forward-bindings)
* [Is Creatable](#is-creatable)
* [Multiple Bindings](#multiple-bindings)
* [Binding Non-owning Pointer](#binding-non-owning-pointer)
* [Binding Templates](#binding-templates)
* [Binding To Constructor](#binding-to-constructor)
* [Automatic Injection](#automatic-injection)
* [Constructor Signature](#constructor-signature)
* [Constructor Injection](#constructor-injection)
* [Multiple Interface](#multiple-interfaces)
* [Annotations](#annotations)
* [Deduce Scope](#deduce-scope)
* [Custom Scope](#custom-scope)
* [Eager Singletons](#eager-singletons)
* [Modules](#modules)
* [Modules (hpp/cpp)](#modules-hppcpp)
* [Custom Policy](#custom-policy)
* [Custom Provider](#custom-provider)
* [Pool Provider](#pool-provider)
* [Configuration](#configuration)
* [Polymorphism](#polymorphism)
    * [Inheritance](#inheritance)
    * [Type-Erasure](#type-erasure)
    * [Function](#function)
    * [Variant](#variant)
    * [Templates](#templates)
    * [Concepts](#concepts)

---

### Hello World
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/try_it.cpp)

### Bindings
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/bindings.cpp)

### Dynamic Bindings
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/dynamic_bindings.cpp)

### Forward Bindings
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/fwd_bindings.cpp)

### Is Creatable
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/is_creatable.cpp)

### Multiple Bindings
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/multiple_bindings.cpp)

### Binding Non-owning Pointer
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/bind_non_owning_ptr.cpp)

### Binding Templates
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/bind_templates.cpp)

### Binding To Constructor
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/bind_to_constructor.cpp)

### Automatic Injection
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/automatic_injection.cpp)

### Constructor Signature
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/constructor_signature.cpp)

### Constructor Injection
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/constructor_injection.cpp)

### Multiple Interface
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/multiple_interfaces.cpp)

### Annotations
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/annotations.cpp)

### Deduce Scope
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/deduce_scope.cpp)

### Custom Scope
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/custom_scope.cpp)

### Eager Singletons
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/eager_singletons.cpp)

### Modules
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/modules.cpp)

### Modules (hpp/cpp)

* See [https://github.com/boost-ext/di/tree/cpp14/example/modules](https://github.com/boost-ext/di/tree/cpp14/example/modules)

### Custom Policy
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/custom_policy.cpp)

### Custom Provider
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/custom_provider.cpp)

### Pool Provider
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/pool_provider.cpp)

### Configuration
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/configuration.cpp)

### Polymorphism
* See [https://github.com/boost-ext/di/tree/cpp14/example/polymorphism](https://github.com/boost-ext/di/tree/cpp14/example/polymorphism)

### Inheritance
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/polymorphism/inheritance.cpp)

### Type Erasure
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/polymorphism/type_erasure.cpp)

### Function
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/polymorphism/function.cpp)

### Variant
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/polymorphism/variant.cpp)

### Templates
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/polymorphism/templates.cpp)

### Concepts
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/example/polymorphism/concepts.cpp)
