* [Injector](#injector)
* [Constructor Bindings](#constructor-bindings)
* [Contextual Bindings](#contextual-bindings)
* [Assisted Injection](#assisted-injection)
* [Extensible Injector](#extensible-injector)
* [Concepts](#concepts)
* [Factory](#factory)
* [Shared Factory](#shared-factory)
* [Lazy](#lazy)
* [Named Parameters](#named-parameters)
* [XML Injection](#xml-injection)
* [Serialize](#serialize)
* [Types Dumper](#types-dumper)
* [UML Dumper](#uml-dumper)
* [Heap Provider](#heap-provider)
* [Mocks Provider](#mocks-provider)
* [Runtime Provider](#runtime-provider)
* [Scoped Scope](#scoped-scope)
* [Session Scope](#session-scope)
* [Shared Scope](#shared-scope)

---

### Injector
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injector.cpp)

### Constructor Bindings
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/bindings/constructor_bindings.cpp)

### Contextual Bindings
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/bindings/contextual_bindings.cpp)

### Assisted Injection
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/assisted_injection.cpp)

### Extensible Injector
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/extensible_injector.cpp)

### Concepts
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/concepts.cpp)

### Factory
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/factory.cpp)

### Shared Factory
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/shared_factory.cpp)

### Lazy
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/lazy.cpp)

### Named Parameters
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/named_parameters.cpp)

### XML Injection
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/injections/xml_injection.cpp)

### Serialize
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/policies/serialize.cpp)

### Types Dumper
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/policies/types_dumper.cpp)

### UML Dumper
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/policies/uml_dumper.cpp)

[![UML Dumper](images/uml_dumper.png)](images/uml_dumper.png)

### Heap Provider
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/providers/heap.cpp)

### Mocks Provider
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/providers/mocks_provider.cpp)

### Runtime Provider
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/providers/runtime_provider.cpp)

### Scoped Scope
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/scopes/scoped.cpp)

### Session Scope
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/scopes/session.cpp)

### Shared Scope
![CPP](https://raw.githubusercontent.com/boost-ext/di/cpp14/extension/test/scopes/shared.cpp)
